// --- [ rs232.c ] -----------------------------------------------------------
// fr Senden und Empfangen via RS232
// Empfangene Daten werden in einen Ringpuffer abgelegt.
// Zu sendende Daten (zum Debuggen) werden direkt pollend ausgegeben.

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <stdlib.h>  
#include "rs232.h"
#include "global.h"

// ----------------------------------------------------------------------------
// 
void RS232_init(void)
{
// ATMEGA88
UBRR0L = TEILER;									// siehe rs232.h
UBRR0H = 0;
UCSR0C = (0<<UMSEL01) | (1<<UCSZ01) | (1<<UCSZ00);
// RX/Tx und Rx_Interrupt enablen
// UCSR0B =	(1<<RXCIE0 | 0<<TXCIE0 | 0<<UDRIE0 | 1<<RXEN0 | 1<<TXEN0);
// hier nur zum Senden von Debug-Informationen vorbereiten
UCSR0B =	(0<<RXCIE0 | 0<<TXCIE0 | 0<<UDRIE0 | 0<<RXEN0 | 1<<TXEN0);
}



// ----------------------------------------------------------------------------
// legt ein via RS232 eingegangenes Byte im public Ringpuffer rx_buffer ab.
// prft nicht, ob der Puffer von hinten her berschrieben wird !
ISR (USART_RX_vect)
{
vnc_buffer[vnc_head++] = UDR0;

if (vnc_head > (VNC_BUFFER_SIZE - 1)) vnc_head = 0; // berlauf verhindern
vnc_bytes_in_buffer++;										 // Zhler fr die Anzahl der Bytes incrementieren
if (vnc_head == vnc_tail) close_file(VNC_CLOSE);	 // Notbremse, wenn der Puffer von hinten her berrollt wird
}


// ----------------------------------------------------------------------------
// ein einzelnes Zeichen auf COM ausgeben
void put_c(uint8_t Zeichen)
{
while(!(UCSR0A & (1<<UDRE0)));
UDR0 = Zeichen;
}

// ----------------------------------------------------------------------------
// einen String auf COM ausgeben
void put_s(char *s)
{
while(*s) put_c(*s++);
}

/*
// ----------------------------------------------------------------------------
// gibt einen String aus dem Flash aus
void puts_p(const char *progmem_s)
{
register char c;
while ( (c = pgm_read_byte(progmem_s++)) )
	{
   put_c(c);
	}
}
*/
// --- [ eof ] ----------------------------------------------------------------